require 'postgres'

class CGI
  class Session
    class PostgreStore
      def initialize(session, option = {})
	pghost = option['pghost']    || nil
	pgport = option['pgport']    || nil
	pgopt  = option['pgoptions'] || nil
	pgdb   = option['pgdb']      || nil
	pguser = option['pguser']    || nil
	pgpass = option['pgpass']    || nil

	@tablename  = option['tablename'] || 'postgrestore'
	@session_id = session.session_id
	@hash       = nil

	@pgconn     = PGconn.connect(pghost, pgport, pgopt, 
				     nil, pgdb, pguser, pgpass)
	r = @pgconn.query("SELECT id FROM #{@tablename} WHERE id = '#{@session_id}'")
	if r.size == 0
	  @pgconn.query("INSERT INTO #{@tablename} VALUES ( '#{@session_id}', '');")
	end
      end

      def restore
	unless @hash
	  r = @pgconn.query("SELECT value FROM #{@tablename} WHERE id = '#{@session_id}'")
	  t = r[0][0].unpack('m')[0]
	  if t.size > 0
	    @hash = Marshal::load(t)
	  else
	    @hash = {}
	  end
	end
	@hash
      end

      def update
	t = [Marshal::dump(@hash)].pack('m')
	@pgconn.query("UPDATE #{@tablename} SET value = '#{t}' WHERE id = '#{@session_id}'")
      end

      def close
	return unless @pgconn
	update
	@pgconn.close
	@pgconn = nil
      end

      def delete
	@pgconn.exec("DELETE FROM #{@tablename} WHERE key = '#{@session_id}';")
      end
    end # PostgreStore
  end # Session
end # CGI
